diff --git a/Android.mk b/Android.mk
index bb49b0b..97a7d75 100644
--- a/Android.mk
+++ b/Android.mk
@@ -26,10 +26,8 @@ include $(CLEAR_VARS)
 
 LIBDRM_TOP := $(LOCAL_PATH)
 
-# Import variables LIBDRM_FILES, LIBDRM_H_FILES
+# Import variables LIBDRM_{,H_,INCLUDE_H_,INCLUDE_VMWGFX_H_}FILES
 include $(LOCAL_PATH)/Makefile.sources
-# Import variables LIBDRM_INCLUDE_H_FILES, LIBDRM_INCLUDE_VMWGFX_H_FILES
-include $(LOCAL_PATH)/include/drm/Makefile.sources
 
 LOCAL_MODULE := libdrm
 LOCAL_MODULE_TAGS := optional
@@ -47,8 +45,8 @@ LOCAL_CFLAGS := \
 
 LOCAL_COPY_HEADERS := \
 	$(LIBDRM_H_FILES) \
-	$(addprefix include/drm/,$(LIBDRM_INCLUDE_H_FILES)) \
-	$(addprefix include/drm/,$(LIBDRM_INCLUDE_VMWGFX_H_FILES))
+	$(LIBDRM_INCLUDE_H_FILES) \
+	$(LIBDRM_INCLUDE_VMWGFX_H_FILES)
 
 LOCAL_COPY_HEADERS_TO := libdrm
 include $(BUILD_SHARED_LIBRARY)
diff --git a/Makefile.am b/Makefile.am
index fab2a9a..083861f 100644
--- a/Makefile.am
+++ b/Makefile.am
@@ -53,7 +53,7 @@ if HAVE_FREEDRENO
 FREEDRENO_SUBDIR = freedreno
 endif
 
-SUBDIRS = . $(LIBKMS_SUBDIR) $(INTEL_SUBDIR) $(NOUVEAU_SUBDIR) $(RADEON_SUBDIR) $(OMAP_SUBDIR) $(EXYNOS_SUBDIR) $(FREEDRENO_SUBDIR) tests include man
+SUBDIRS = . $(LIBKMS_SUBDIR) $(INTEL_SUBDIR) $(NOUVEAU_SUBDIR) $(RADEON_SUBDIR) $(OMAP_SUBDIR) $(EXYNOS_SUBDIR) $(FREEDRENO_SUBDIR) tests man
 
 libdrm_la_LTLIBRARIES = libdrm.la
 libdrm_ladir = $(libdir)
@@ -71,6 +71,14 @@ libdrminclude_HEADERS = $(LIBDRM_H_FILES)
 
 EXTRA_DIST = libdrm.pc.in include/drm/*
 
+klibdrmincludedir = ${includedir}/libdrm
+klibdrminclude_HEADERS = $(LIBDRM_INCLUDE_H_FILES)
+
+if HAVE_VMWGFX
+klibdrminclude_HEADERS += $(LIBDRM_INCLUDE_VMWGFX_H_FILES)
+endif
+
+
 copy-headers :
 	cp -r $(kernel_source)/usr/include/drm $(top_srcdir)/include
 
diff --git a/Makefile.sources b/Makefile.sources
index d078ca9..d86fb2a 100644
--- a/Makefile.sources
+++ b/Makefile.sources
@@ -11,3 +11,22 @@ LIBDRM_FILES := \
 LIBDRM_H_FILES := \
 	xf86drm.h \
 	xf86drmMode.h
+
+LIBDRM_INCLUDE_H_FILES := \
+	include/drm/drm.h \
+	include/drm/drm_fourcc.h \
+	include/drm/drm_mode.h \
+	include/drm/drm_sarea.h \
+	include/drm/i915_drm.h \
+	include/drm/mach64_drm.h \
+	include/drm/mga_drm.h \
+	include/drm/nouveau_drm.h \
+	include/drm/qxl_drm.h \
+	include/drm/r128_drm.h \
+	include/drm/radeon_drm.h \
+	include/drm/savage_drm.h \
+	include/drm/sis_drm.h \
+	include/drm/via_drm.h
+
+LIBDRM_INCLUDE_VMWGFX_H_FILES := \
+	include/drm/vmwgfx_drm.h
diff --git a/configure.ac b/configure.ac
index bb0559a..16625a5 100644
--- a/configure.ac
+++ b/configure.ac
@@ -410,8 +410,6 @@ AC_CONFIG_FILES([
 	tests/radeon/Makefile
 	tests/vbltest/Makefile
 	tests/exynos/Makefile
-	include/Makefile
-	include/drm/Makefile
 	man/Makefile
 	libdrm.pc])
 AC_OUTPUT
diff --git a/include/Makefile.am b/include/Makefile.am
deleted file mode 100644
index 55ea506..0000000
--- a/include/Makefile.am
+++ /dev/null
@@ -1 +0,0 @@
-SUBDIRS = drm
diff --git a/include/drm/Makefile.am b/include/drm/Makefile.am
deleted file mode 100644
index 7a246ae..0000000
--- a/include/drm/Makefile.am
+++ /dev/null
@@ -1,32 +0,0 @@
-#  Copyright 2005 Adam Jackson.
-#
-#  Permission is hereby granted, free of charge, to any person obtaining a
-#  copy of this software and associated documentation files (the "Software"),
-#  to deal in the Software without restriction, including without limitation
-#  on the rights to use, copy, modify, merge, publish, distribute, sub
-#  license, and/or sell copies of the Software, and to permit persons to whom
-#  the Software is furnished to do so, subject to the following conditions:
-#
-#  The above copyright notice and this permission notice (including the next
-#  paragraph) shall be included in all copies or substantial portions of the
-#  Software.
-#
-#  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
-#  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
-#  FITNESS FOR A PARTICULAR PURPOSE AND NON-INFRINGEMENT.  IN NO EVENT SHALL
-#  ADAM JACKSON BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
-#  IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
-#  CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
-
-# XXX airlied says, nothing besides *_drm.h and drm*.h should be necessary.
-# however, r300 and via need their reg headers installed in order to build.
-# better solutions are welcome.
-
-include Makefile.sources
-
-klibdrmincludedir = ${includedir}/libdrm
-klibdrminclude_HEADERS = $(LIBDRM_INCLUDE_H_FILES)
-
-if HAVE_VMWGFX
-klibdrminclude_HEADERS += $(LIBDRM_INCLUDE_VMWGFX_H_FILES)
-endif
diff --git a/include/drm/Makefile.sources b/include/drm/Makefile.sources
deleted file mode 100644
index 8e1b585..0000000
--- a/include/drm/Makefile.sources
+++ /dev/null
@@ -1,18 +0,0 @@
-LIBDRM_INCLUDE_H_FILES := \
-	drm.h \
-	drm_mode.h \
-	drm_fourcc.h \
-	drm_sarea.h \
-	i915_drm.h \
-	mga_drm.h \
-	nouveau_drm.h \
-	r128_drm.h \
-	radeon_drm.h \
-	savage_drm.h \
-	sis_drm.h \
-	via_drm.h \
-	mach64_drm.h \
-	qxl_drm.h
-
-LIBDRM_INCLUDE_VMWGFX_H_FILES := \
-	vmwgfx_drm.h