diff --git a/Android.mk b/Android.mk
index 1d8cd65..2aa2bc9 100644
--- a/Android.mk
+++ b/Android.mk
@@ -32,7 +32,7 @@ include $(CLEAR_VARS)
 LOCAL_MODULE := libdrm
 LOCAL_MODULE_TAGS := optional
 
-LOCAL_SRC_FILES := $(LIBDRM_FILES)
+LOCAL_SRC_FILES := $(patsubst %.h, , $(LIBDRM_FILES))
 LOCAL_EXPORT_C_INCLUDE_DIRS := \
 	$(LOCAL_PATH) \
 	$(LOCAL_PATH)/include/drm
@@ -50,7 +50,7 @@ include $(CLEAR_VARS)
 LOCAL_MODULE := libdrm
 LOCAL_MODULE_TAGS := optional
 
-LOCAL_SRC_FILES := $(LIBDRM_FILES)
+LOCAL_SRC_FILES := $(patsubst %.h, , $(LIBDRM_FILES))
 LOCAL_EXPORT_C_INCLUDE_DIRS := \
         $(LOCAL_PATH) \
         $(LOCAL_PATH)/include/drm
diff --git a/amdgpu/Android.mk b/amdgpu/Android.mk
index 469df1b..57c53a7 100644
--- a/amdgpu/Android.mk
+++ b/amdgpu/Android.mk
@@ -9,7 +9,7 @@ LOCAL_MODULE_TAGS := optional
 
 LOCAL_SHARED_LIBRARIES := libdrm
 
-LOCAL_SRC_FILES := $(LIBDRM_AMDGPU_FILES)
+LOCAL_SRC_FILES := $(patsubst %.h, , $(LIBDRM_AMDGPU_FILES))
 LOCAL_EXPORT_C_INCLUDE_DIRS := $(LOCAL_PATH)
 
 LOCAL_CFLAGS := \
diff --git a/freedreno/Android.mk b/freedreno/Android.mk
index 2645f73..fba48f2 100644
--- a/freedreno/Android.mk
+++ b/freedreno/Android.mk
@@ -9,7 +9,7 @@ LOCAL_MODULE_TAGS := optional
 
 LOCAL_SHARED_LIBRARIES := libdrm
 
-LOCAL_SRC_FILES := $(LIBDRM_FREEDRENO_FILES)
+LOCAL_SRC_FILES := $(patsubst %.h, , $(LIBDRM_FREEDRENO_FILES))
 LOCAL_EXPORT_C_INCLUDE_DIRS := $(LOCAL_PATH)
 
 LOCAL_CFLAGS := \
diff --git a/intel/Android.mk b/intel/Android.mk
index 6582dfd..838a93b 100644
--- a/intel/Android.mk
+++ b/intel/Android.mk
@@ -30,7 +30,7 @@ include $(LOCAL_PATH)/Makefile.sources
 LOCAL_MODULE := libdrm_intel
 LOCAL_MODULE_TAGS := optional
 
-LOCAL_SRC_FILES := $(LIBDRM_INTEL_FILES)
+LOCAL_SRC_FILES := $(patsubst %.h, , $(LIBDRM_INTEL_FILES))
 LOCAL_EXPORT_C_INCLUDE_DIRS := $(LOCAL_PATH)
 
 LOCAL_CFLAGS := \
diff --git a/libkms/Android.mk b/libkms/Android.mk
index a406782..cf0e9bb 100644
--- a/libkms/Android.mk
+++ b/libkms/Android.mk
@@ -26,7 +26,7 @@ LOCAL_PATH := $(call my-dir)
 include $(CLEAR_VARS)
 include $(LOCAL_PATH)/Makefile.sources
 
-LOCAL_SRC_FILES := $(LIBKMS_FILES)
+LOCAL_SRC_FILES := $(patsubst %.h, , $(LIBKMS_FILES))
 
 ifneq ($(filter $(vmwgfx_drivers), $(DRM_GPU_DRIVERS)),)
 LOCAL_SRC_FILES += $(LIBKMS_VMWGFX_FILES)
diff --git a/nouveau/Android.mk b/nouveau/Android.mk
index abc6aef..b67d30f 100644
--- a/nouveau/Android.mk
+++ b/nouveau/Android.mk
@@ -9,7 +9,7 @@ LOCAL_MODULE_TAGS := optional
 
 LOCAL_SHARED_LIBRARIES := libdrm
 
-LOCAL_SRC_FILES := $(LIBDRM_NOUVEAU_FILES)
+LOCAL_SRC_FILES := $(patsubst %.h, , $(LIBDRM_NOUVEAU_FILES))
 LOCAL_EXPORT_C_INCLUDE_DIRS := $(LOCAL_PATH)
 
 LOCAL_CFLAGS := \
diff --git a/radeon/Android.mk b/radeon/Android.mk
index ace3408..e704443 100644
--- a/radeon/Android.mk
+++ b/radeon/Android.mk
@@ -9,7 +9,7 @@ LOCAL_MODULE_TAGS := optional
 
 LOCAL_SHARED_LIBRARIES := libdrm
 
-LOCAL_SRC_FILES := $(LIBDRM_RADEON_FILES)
+LOCAL_SRC_FILES := $(patsubst %.h, , $(LIBDRM_RADEON_FILES))
 LOCAL_EXPORT_C_INCLUDE_DIRS := $(LOCAL_PATH)
 
 LOCAL_CFLAGS := \
diff --git a/tests/modetest/Android.mk b/tests/modetest/Android.mk
index e616558..6a7f406 100644
--- a/tests/modetest/Android.mk
+++ b/tests/modetest/Android.mk
@@ -3,7 +3,7 @@ LOCAL_PATH := $(call my-dir)
 include $(CLEAR_VARS)
 include $(LOCAL_PATH)/Makefile.sources
 
-LOCAL_SRC_FILES := $(MODETEST_FILES)
+LOCAL_SRC_FILES := $(patsubst %.h, , $(MODETEST_FILES))
 
 LOCAL_MODULE := modetest
 
diff --git a/tests/proptest/Android.mk b/tests/proptest/Android.mk
index d0ab5c9..badeb58 100644
--- a/tests/proptest/Android.mk
+++ b/tests/proptest/Android.mk
@@ -3,7 +3,7 @@ LOCAL_PATH := $(call my-dir)
 include $(CLEAR_VARS)
 include $(LOCAL_PATH)/Makefile.sources
 
-LOCAL_SRC_FILES := $(PROPTEST_FILES)
+LOCAL_SRC_FILES := $(patsubst %.h, , $(PROPTEST_FILES))
 
 LOCAL_MODULE := proptest
 
diff --git a/tests/util/Android.mk b/tests/util/Android.mk
index 73bc680..1bd82ae 100644
--- a/tests/util/Android.mk
+++ b/tests/util/Android.mk
@@ -31,7 +31,7 @@ LOCAL_MODULE_TAGS := optional
 
 LOCAL_SHARED_LIBRARIES := libdrm
 
-LOCAL_SRC_FILES := $(UTIL_FILES)
+LOCAL_SRC_FILES := $(patsubst %.h, , $(UTIL_FILES))
 
 # avoid name clashes by requiring users to include util/*.h
 LOCAL_EXPORT_C_INCLUDE_DIRS := $(dir $(LOCAL_PATH))